package aa14b.rest.resources;

import javax.inject.Inject;
import javax.inject.Singleton;
import javax.ws.rs.Path;

import aa14b.rest.resources.delegates.AA14RESTCRUDDelegateForOrgDivision;
import aa14f.api.interfaces.AA14CRUDServicesForOrgDivision;
import aa14f.model.AA14OrgDivision;
import aa14f.model.oids.AA14IDs.AA14OrgDivisionID;
import aa14f.model.oids.AA14OIDs.AA14OrgDivisionOID;
import aa14f.server.rest.resources.AA14RESTCRUDResourceBaseForOrganizationalEntity;
import lombok.experimental.Accessors;

/**
 * The implementation must follow the HTTP 1.1 spec (http://www.w3.org/Protocols/rfc2616/rfc2616.html), specifically
 * the section about the methods (GET, PUT, POST, DELETE...)
 *
 * Log: see web.xml
 */
@Path("divisions")
@Singleton
@Accessors(prefix="_")
public class AA14RESTCRUDResourceForOrgDivision
	 extends AA14RESTCRUDResourceBaseForOrganizationalEntity<AA14OrgDivisionOID,AA14OrgDivisionID,AA14OrgDivision> {
/////////////////////////////////////////////////////////////////////////////////////////
//	CONSTRUCTOR
/////////////////////////////////////////////////////////////////////////////////////////
	@Inject
	public AA14RESTCRUDResourceForOrgDivision(final AA14CRUDServicesForOrgDivision crudServices) {
		super(new AA14RESTCRUDDelegateForOrgDivision(crudServices));
	}
}
